#include <HCSR04.h>  //ultrasound sensor library
#include <Servo.h>  //servo motor library

Servo servo;  //servo variable definition
int led1 = A2; //first led of the rgb led variable definition and the pin its connected to
int led2 = A1; //second led of the rgb led variable definition and the pin its connected to
int led3 = A3; //third led of the rgb led variable definition and the pin its connected to
unsigned long last1; //first time variable definition with long since its a really long number
unsigned long last2; //second time variable definition with long since its a really long number
unsigned long last3; //third time variable definition with long since its a really long number
long duration, distance; //definition of the duartion and distance variables that we will use for the sensor's code
bool lucesybuzzer; //definiton of the boolean variable that will indicate whether the leds and buzzer have to be on or off
bool motorAbierto; //definition of the boolean variable that will indicate whether the pot's lid is open, therefore the motor is turned, or not.
bool ida; //definition of the boolean variable that will indicate which way the leds color is fading, either from blue to purple or from purple to blue
int i; //definition of the variable that we will use to regulate the leds
int t; //definition of the variable that we will use to regulate the music
int buzzer; //definition of the buzzer variable
HCSR04 hc(5, 6);  //initialisation class HCSR04 (trig pin , echo pin)

//Definition of the music notes:
int c[5] = { 131, 262, 523, 1046, 2093 }; //C note
int cs[5] = { 139, 277, 554, 1108, 2217 }; //C# note
int d[5] = { 147, 294, 587, 1175, 2349 }; //D note
int ds[5] = { 156, 311, 622, 1244, 2489 }; //D# note
int e[5] = { 165, 330, 659, 1319, 2637 }; //E note
int f[5] = { 175, 349, 698, 1397, 2794 }; //F note
int fs[5] = { 185, 370, 740, 1480, 2960 }; //F# note
int g[5] = { 196, 392, 784, 1568, 3136 }; //G note
int gs[5] = { 208, 415, 831, 1661, 3322 }; //G# note
int a[5] = { 220, 440, 880, 1760, 3520 }; //A note
int as[5] = { 233, 466, 932, 1866, 3729 }; //A# note
int b[5] = { 247, 494, 988, 1976, 3951 }; //B note

//definition of the musical melody array:
int musica[][34] = { { 0, b[2], e[3], g[3], fs[3], e[3], b[3], a[3], fs[3], b[2], e[3], g[3], fs[3], d[3], e[3], b[2], -1, b[2], e[3], g[3], fs[3], e[3], b[3], d[4], cs[4], c[4], a[3], c[4], b[3], as[3], b[2], g[3], e[3], -1 }, //first line of the array where each music note is defined
                     { 0, 500, 1000, 250, 250, 1000, 500, 1250, 1000, 500, 1000, 250, 250, 1000, 500, 1000, 1000, 500, 1000, 250, 250, 1000, 500, 1000, 500, 1000, 500, 1000, 250, 250, 1000, 500, 1000, 2000 } }; //second line of the array where each note's duration is defined


void setup() { //part of the code where we define the setup 
  Serial.begin(9600); //we use this to set the data rate in bits per second, for serial data transmission
  servo.attach(10); //definition of the pin we have attached the servo motor to
  pinMode(led1, OUTPUT); //configuration of the first rgd led's pin to behave as an output
  pinMode(led2, OUTPUT); //configuration of the second rgd led's pin to behave as an output
  pinMode(led3, OUTPUT); //configuration of the third rgd led's pin to behave as an output
  buzzer = 9; //definition of the buzzer pin
  pinMode(9, OUTPUT); //configuration of the buzzer's pin to behave as an output
  motorAbierto = false; //setting of the motor's boolean variable to start as false
  lucesybuzzer = false; //setting of the led's and buzzer's boolean variable to start as false
  last1 = millis(); //activate the last1 counter
  last2 = millis(); //activate the last2 counter
  last3 = millis(); //activate the last3 counter
  t = 0; //setting the t variable to start at 0
  i = 0; //setting the i variable to start at 0
}

void nota(int frec, int t) { //part of the code that makes each tone sound
  tone(buzzer, frec); //for each tone, activate the buzzer and the frequency variables
}

void loop() { //part of the code where we put the main functions in a loop
  if (i < 0) { //when i is less than 0
    ida = true; //the first way of the fading led color starts, from blue to purple
  }

  if (i > 255) { //when i is higher than 255
    ida = false; //the way back of the fading led color starts, from purple to blue
  }

  distance = hc.dist(); //define the distance variable to be the distance captured by the sensor
  Serial.println(distance); //we use this to print the distance captured by the ultrasound sensor
  if ((distance < 10) && (motorAbierto == false)) { //when the distance is less than 10 cm and the pot's lid is closed,
    Serial.println("caso 1"); //we use this to get notified when this if is activated
    lucesybuzzer = true; //turn the leds and buzzer on
    motorAbierto = true; //turn the state of the lid to open
    servo.write(75); //make the motor turn 75º to open up the lid
    delay(1000); //wait 1 second for the motor to finish turning
    last1 = millis(); //active the last1 counter
    last2 = millis(); //activate the last2 counter
  }

  if (millis() - last3 > musica[1][t] && lucesybuzzer == true) { //if the time difference from when we started the last3 counter to now is bigger than the action's duration (the music note's duration) and the led and buzzer are activated
    t++; //this keeps adding up to the following note
    int f = musica[0][t]; //definition of the first music array's line
    int dur = musica[1][t]; //definition of the second music array's line
    last3 = millis(); //reactivate the last3 counter
    if (f > 0) { //when f is bigger than 0,
      tone(buzzer, f); //make the buzzer sound with the corresponding note
    } else { //when f is less or equal to 0,
      noTone(buzzer); //make no sounds with the buzzer
    }
    delay(dur); //wait for each of the tone's duration
  } else { //when something form this if is not happening,
    t = 0; //t is 0, so the first position of the music array's, that is silence
  }

  if (millis() - last1 > 60 && lucesybuzzer == true && ida == true) { //if the time difference from when we started the last1 counter to now is bigger than 60, the leds and buzzer are activated and it is time for the first way of the fading colors (from blue to purple), 

    analogWrite(led1, 255); //make the first rgd led stay at 255
    analogWrite(led2, (255 / 2) - (i / 2)); //make the second rgb led start at 127,5 and subtract half the i's value each time
    analogWrite(led3, i); //make the third rgb led the i's value
    i = i + 5; //add 5 to i each time
    last1 = millis(); //reactivate the last1 counter
  }

  if (millis() - last1 > 60 && lucesybuzzer == true && ida == false) { //if the time difference from when we started the last1 counter to now is bigger than 60 milliseconds, the leds and buzzer are activated and it is time for the way back of the fading colors (from purple to blue), 
    analogWrite(led1, 255); //make the first rgd led stay at 255
    analogWrite(led2, (255 / 2) - (i / 2)); ////make the second rgb led start at 127,5 and subtract half the i's value each time
    analogWrite(led3, i); //make the third rgb led the i's value
    i = i - 5; //subtract 5 to i each time
    last1 = millis(); //reactivate the last1 counter
  }

  if (millis() - last2 > 15000) { //if the time difference from when we started the last1 counter to now is bigger than 15 seconds, when we want everything to shut down
    Serial.println("Caso 3"); //we use this to get notified when this if is activated
    lucesybuzzer = false; //turn the leds and buzzer off
    analogWrite(led1, 0); //turn the first rgb led off
    analogWrite(led2, 0); //turn the second rgb led off
    analogWrite(led3, 0); //turn the third rgb led off
    motorAbierto = false; //close the lid
    noTone(buzzer); //shut the buzzer down
    last1 = millis(); //reactivate the last1 counter
    last2 = millis(); //reactivate the last2 counter
    last3 = millis(); //reactivate the last3 counter
    servo.write(0); //turn the servo motor to 0º  
    delay(2000); //wait 2 seconds for everything to stop
  }
}